#include<stdio.h>
#include<stdlib.h>

typedef struct nodo *nodoptr;
typedef struct nodo
    {
    int data;
    nodoptr left;
    nodoptr right;
    };
    
nodoptr leggi_preordine();

void stampa_preordine(nodoptr);
void stampa_inordine(nodoptr);
void stampa_postordine(nodoptr);

void mettiazerofoglie(nodoptr);

int main()
    {
    int c;
    nodoptr rad;
    
    rad=leggi_preordine();
    mettiazerofoglie(rad);

    printf("Ora stampa in preordine\n\n\n");
    stampa_preordine(rad);

scanf("%d", & c);
    }
    
    
nodoptr leggi_preordine()
    {
    int intero, sin, des;
    nodoptr radice=(nodoptr)malloc(sizeof(struct nodo));

//DATA
    printf("Inserisci il nodo:\t");
    scanf("%d",& intero);
    radice->data=intero;

//FIGLIO SINISTRO

    printf("Il nodo ha figlio sinistro?");
    scanf("%d",& sin);
    if(sin==1)
        {
        radice->left=leggi_preordine();
        }
    else
        radice->left=NULL;

//FIGLIO DESTRO

    printf("Il nodo ha figlio destro?");
    scanf("%d",& des);

    if(des==1)
        {
        radice->right=leggi_preordine();
        }
    else
        radice->right=NULL;
        
        
    return radice;
    }
    
void stampa_preordine(nodoptr radice)
    {
    if(radice != NULL)
         {
         printf("%d\n", radice->data);
         stampa_preordine(radice->left);
         stampa_preordine(radice->right);
         }
    }
    
void stampa_inordine(nodoptr radice)
    {
    if(radice != NULL)
         {
         stampa_preordine(radice->left);
         printf("%d\n", radice->data);
         stampa_preordine(radice->right);
         }
    }

void stampa_postordine(nodoptr radice)
    {
    if(radice != NULL)
         {
         stampa_preordine(radice->left);
         stampa_preordine(radice->right);
         printf("%d\n", radice->data);
         }
    }


void mettiazerofoglie(nodoptr radice)
    {
    if(radice != NULL)
         {
         if((radice->left == NULL) && (radice->right==NULL))
                  radice->data=0;

         mettiazerofoglie(radice->left);
         mettiazerofoglie(radice->right);
         }
    }



